#ifndef __ip_h__
#define __ip_h__

#include "type.h"

struct Ip
{
	RelativeRef<Ube16,0> words;
	struct Address
	{
		U8 bytes[4];
		inline void operator=(const Address& ad)
		{
			*(U32*)this=*(U32*)&ad;
		}
		inline bool operator==(const Address& ad)
		{
			return *(U32*)this==*(U32*)&ad;
		}
		inline bool operator!=(const Address& ad)
		{
			return !(*this==ad);
		}

	};
	RelativeField<U8,0,0,4> headerLength;
	RelativeField<U8,0,4,4> version;
	Relative<U8, 1,U8> services;
	Relative<U16,2,Ube16> totalLength;
	Relative<U16,4,Ube16> identification;
	Relative<U16,6,Ube16> ff;
	RelativeField<Ube16, 6,0,12> fragmentOffset;
	RelativeField<Ube16, 6,12,4> flags;
	Relative<U8, 8,U8> ttl;
	Relative<U8, 9,U8> protocol;
	Relative<U16,10,Ube16> headerChecksum;
	Relative<U16,10,U16> checksum;
	RelativeRef<Address,12> source;
	RelativeRef<Address,16> destination;
	RelativeRef<U8,20> options;
	U8 buf[0];
	inline U32 headerSize()
	{
		return headerLength*4;
	}
	inline U8 *data()
	{
		return buf+headerSize();
	}
	U16 checkSum(U8 *data,U32 len);
	inline void checkSumSet()
	{
		checksum=0;
		checksum=~checkSum(buf,headerSize());
	}
	bool checkSumGood()
	{
		return checkSum(buf,headerSize())==(U16)~0;
	}
};

#endif /* __ip_h__ */
