#ifndef __nb_h__
#define __nb_h__

/* North Bridge registers */

struct NbReg
{
	Relative<U16,0,Io<U16> > addr;
	Relative<U16,2,Io<U16> > data;
};

#define nbReg ((NbReg*)0x24)

/*
struct Nb8
{
	U8 justForPointerArithmetic;
	inline void operator =(U8 v)
	{
		nbReg->addr=(U8)this;
		nbReg->data8=v;
	}
	inline operator U8()
	{
		nbReg->addr=(U8)this;
		return nbReg->data8;
	}
};
*/

struct Nb16
{
	// les index on un increment de un
	// malgre une taille de data de 2 octets
	U8 justForPointerArithmetic;
	inline void operator =(U16 v)
	{
		nbReg->addr=(U16)(U32)this;
		nbReg->data=v;
	}
	inline operator U16()
	{
		nbReg->addr=(U16)(U32)this;
		return nbReg->data;
	}
};


struct NbRegs
{
	Relative<U16,0x0100,Nb16> version;
	Relative<U16,0x0110,Nb16> programmableRegion1;
	Relative<U16,0x0111,Nb16> programmableRegion2;
	Relative<U16,0x0112,Nb16> programmableRegion3;
	Relative<U16,0x0113,Nb16> programmableRegion4;
	Relative<U16,0x0114,Nb16> programmableRegionControl;
	Relative<U16,0x0115,Nb16> cacheabilityOverride;
	Relative<U16,0x0117,Nb16> backoffControl;
	Relative<U16,0x0118,Nb16> smmControl;
	Relative<U16,0x0119,Nb16> processorControl;
	Relative<U16,0x011a,Nb16> writeFifoControl;
	Relative<U16,0x011b,Nb16> pciControl;
	Relative<U16,0x011c,Nb16> clockSkewAdjust;
	Relative<U16,0x011d,Nb16> snoopControl;
	Relative<U16,0x011e,Nb16> arbiterControl;
	Relative<U16,0x0120,Nb16> pciWriteFifoControl;

	Relative<U16,0x0200,Nb16> shadowRamReadEnable;
	Relative<U16,0x0201,Nb16> shadowRamWriteEnable;
	struct Bank {
		Relative<U16,0x0000,Nb16> control;
		Relative<U16,0x0002,Nb16> timing;
	};
	RelativeRef<Bank,0x0202> banks;
	Relative<U16,0x0202,Nb16> bank0Control;
	Relative<U16,0x0204,Nb16> bank0Timing;
	Relative<U16,0x0205,Nb16> bank1Control;
	Relative<U16,0x0207,Nb16> bank1Timing;
	Relative<U16,0x0208,Nb16> bank2Control;
	Relative<U16,0x020a,Nb16> bank2Timing;
	Relative<U16,0x020b,Nb16> bank3Control;
	Relative<U16,0x020d,Nb16> bank3Timing;
	Relative<U16,0x020e,Nb16> dramConfiguration1;
	Relative<U16,0x020f,Nb16> dramConfiguration2;
	Relative<U16,0x0211,Nb16> dramRefresh;
	Relative<U16,0x0213,Nb16> sdramModeProgram;
	Relative<U16,0x0214,Nb16> sdramModeProgramEx;
	Relative<U16,0x0239,Nb16> sdramSlewControl;

	Relative<U16,0x0300,Nb16> clockControl;
	Relative<U16,0x03ff,Nb16> clockControl2;

	Relative<U16,0x0238,Nb16> cpuSync;
};

#define nbRegs ((NbRegs*)0)

#endif /* __nb_h__ */
